<?php
session_start();
date_default_timezone_set('PRC');
if(!isset($_POST['DATA'])){exit('DATA NULL');}
/***************************************************建议尽量不要用记事本修改本文件,请用Notepade++之类的工具编辑*/
$dbhost = 'localhost';								/*数据库主机(非特殊情况建议别修改这里)*/
$dbuser = 'test';									/*数据库用户名*/
$dbpass = '12345678';								/*数据库密码*/
$ischar = 'utf8';									/*数据库字符集*/
$datkey = 'e10adc3949ba59abbe56e057f20f883e';		/*通信密钥,必须和模块里面的解密数据使用的密钥一样*/
/***************************************************/


if($_POST['DATA']=='PDOSTART'){$formhash = randStr(10);$_SESSION['formhash']=$formhash;exit('dat->'.rc4(gzencode($formhash),$datkey));}/*取令牌*/
if(strlen($_POST['formhash'])!=10){exit('ERR POST FORMHASH');}
if(md5($_SESSION['formhash'])!=md5($_POST['formhash'])){exit('ERR FORMHASH');}$dataTem = str_decode($_POST['DATA']);
if(md5(getSignature($dataTem,$datkey.$_POST['formhash']))!=md5($_POST['sign'])){exit('ERR SIGN');}

$datArr=explode('[{!}]',$dataTem);$tplArr=getTplArr($datArr[4]);$dbTitle=explode('[{?}]',$datArr[1]);$datArr[1]=$dbTitle[1];
try{/*连接数据库*/
	$pdo = new PDO("mysql:host={$dbhost};dbname={$dbTitle[0]};charset={$ischar}",$dbuser,$dbpass);
	$pdo -> setAttribute(PDO::ATTR_ERRMODE,PDO::ERRMODE_EXCEPTION);
	$pdo -> setAttribute(PDO::ATTR_EMULATE_PREPARES, false);
	$pdo -> query("SET NAMES {$ischar}");
}catch(PDOException $e){exit($e->getMessage());}
session_destroy();
switch ($datArr[0]){
case 'QUE':
	if($datArr[3]=='*'){$sql = "SELECT {$datArr[2]}";
	}else{if(in_arrayfun($datArr[3],array('=','LIKE','AND','>','<','!='))){$datArr[3]=' WHERE '.$datArr[3];}
	$sql = "SELECT {$datArr[2]} FROM {$datArr[1]} {$datArr[3]}";}
	$res = $pdo->prepare($sql);$json = '';
	if($res->execute($tplArr)){$json = json_encode($res->fetchAll(PDO::FETCH_ASSOC));}
	exit('dat->'.str_encode($json));
case 'INS':
	$res = $pdo->prepare("INSERT INTO {$datArr[1]} ({$datArr[2]}) VALUES ({$datArr[3]})");
	$json = json_encode($res->execute($tplArr));
	exit('dat->'.str_encode($json));
case 'UPD':
	$res = $pdo->prepare("UPDATE {$datArr[1]} SET {$datArr[2]} WHERE {$datArr[3]}");
	$json = json_encode($res->execute($tplArr));
	exit('dat->'.str_encode($json));
case 'DEL':
	$res = $pdo->prepare("DELETE FROM {$datArr[1]} WHERE {$datArr[3]}");
	$json = json_encode($res->execute($tplArr));
	exit('dat->'.str_encode($json));
case 'SQL':
	$retArr = array();
	if(substr($datArr[1],0,5)=='EXEC;'){
		$datArr[1]=substr($datArr[1],5,strlen($datArr[1])-5);
		$res = $pdo->exec($datArr[1]);
		if($res===false){echo 'ERROR->'.$pdo->errorInfo();exit;}
		exit('dat->'.str_encode('Affected rows:'.$res));
	}
	if(substr($datArr[1],0,6)=='BEGIN;'){
		$datArr[1]=substr($datArr[1],6,strlen($datArr[1])-6);
		$sqlArr = explode(';', $datArr[1]);
		try{$pdo->beginTransaction();foreach($sqlArr as $v){if(strlen($v) > 2){
			$res = $pdo->prepare($v);
			if(substr(strtoupper($v),0,6) == 'SELECT'){
				$res->execute();
				array_push($retArr, $res->fetchAll(PDO::FETCH_ASSOC));
			}else{array_push($retArr, $res->execute());}
		}}$pdo->commit();exit('dat->'.str_encode(json_encode($retArr)));
		}catch(PDOException $e){echo 'TRANSACTION ERROR->'.$e->getMessage();$pdo->rollback();exit(json_encode($retArr));}
	}
	$sqlArr = explode(';', $datArr[1]);if(count($sqlArr) > 1){
		foreach($sqlArr as $v){if(strlen($v) > 2){
			$res = $pdo->prepare($v);
			if(substr(strtoupper($v),0,6) == 'SELECT'){
				$res->execute();
				array_push($retArr, $res->fetchAll(PDO::FETCH_ASSOC));
			}else{array_push($retArr, $res->execute());}
		}}exit('dat->'.str_encode(json_encode($retArr)));}
	$res = $pdo->prepare($datArr[1]);
	if($datArr[2]==0){$json = json_encode($res->execute($tplArr));
	}else{$res->execute($tplArr);$json = json_encode($res->fetchAll(PDO::FETCH_ASSOC));}
	exit('dat->'.str_encode($json));
}
function getTplArr($val){
	$arrVal = array();
	if(strlen($val) < 1){return $arrVal;}
	$arr = explode(',',$val);
	foreach($arr as $k=>$v){$arrVal[] = $v;}
	return $arrVal;
}
function str_decode($hex){
	global $datkey;return (string)gzdecode(rc4($hex,$datkey));
}
function str_encode($str){
	global $datkey;
	$str = gzencode($str);
	return rc4($str,$_POST['formhash'].$datkey.$_POST['formhash']);
}
function getSignature($str, $key){
	$blocksize = 64;
	$hashfunc = 'sha1';
	if (strlen($key) > $blocksize) {$key = pack('H*', sha1($key));}
	$key = str_pad($key, $blocksize, chr(0x00));
	$ipad = str_repeat(chr(0x36), $blocksize);
	$opad = str_repeat(chr(0x5c), $blocksize);
	$hmac = pack('H*', $hashfunc(($key ^ $opad) . pack('H*', $hashfunc(($key ^ $ipad) . md5($str)))));
	return md5($hmac);
}
function in_arrayfun($str,$arr){
	foreach($arr as $v){
		if(strrpos(strtoupper($str),$v)!==FALSE){return true;}
	}
	return false;
}
function randStr($length){
	$strPol = 'ABCDEFGHKLMNPRSTUVWXYZ23456789';
	$max = strlen($strPol)-1;
	for($i=0;$i<$length;$i++){@$str .= $strPol[mt_rand(0,$max)];}
	return $str;
}
function rc4($data,$pwd){  
	$key[] = $box[] = $cipher ="";
	$pwd_length = strlen($pwd);
	$data_length = strlen($data);
	for ($i = 0; $i < 256; $i++){
		$key[$i] = ord($pwd[$i % $pwd_length]);
		$box[$i] = $i;
	}
	for ($j = $i = 0; $i < 256; $i++){
		$j = ($j + $box[$i] + $key[$i]) % 256;
		$tmp = $box[$i];
		$box[$i] = $box[$j];
		$box[$j] = $tmp;
	}
	for ($a = $j = $i = 0; $i < $data_length; $i++){
		$a = ($a + 1) % 256;
		$j = ($j + $box[$a]) % 256;
		$tmp = $box[$a];
		$box[$a] = $box[$j];
		$box[$j] = $tmp;
		$k = $box[(($box[$a] + $box[$j]) % 256)];
		$cipher .= chr(ord($data[$i]) ^ $k);
	}
	return $cipher;
}





